/* CropView.c generated by valac 0.56.11, the Vala compiler
 * generated from CropView.vala, do not modify */

/*
* Copyright (c) 2014-2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Tom Beckmann
*              Marvin Beckers <beckersmarvin@gmail.com>
*/

#include "useraccounts.h"
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib-object.h>

#define SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS 12

enum  {
	SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_0_PROPERTY,
	SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY,
	SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_NUM_PROPERTIES
};
static GParamSpec* switchboard_plug_user_accounts_widgets_crop_view_properties[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL,
	SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_NUM_SIGNALS
};
static guint switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_NUM_SIGNALS] = {0};

struct _SwitchboardPlugUserAccountsWidgetsCropViewPrivate {
	GdkRectangle area;
	GdkPixbuf* _pixbuf;
	gdouble current_scale;
	gint* pos;
	gint pos_length1;
	gint pos_length2;
	GdkCursorType current_operation;
	gint temp_x;
	gint temp_y;
	gint offset_x;
	gint offset_y;
	gboolean mouse_button_down;
};

static gint SwitchboardPlugUserAccountsWidgetsCropView_private_offset;
static gpointer switchboard_plug_user_accounts_widgets_crop_view_parent_class = NULL;

static gboolean switchboard_plug_user_accounts_widgets_crop_view_real_button_press_event (GtkWidget* base,
                                                                                   GdkEventButton* event);
static gboolean switchboard_plug_user_accounts_widgets_crop_view_real_motion_notify_event (GtkWidget* base,
                                                                                    GdkEventMotion* event);
static gboolean switchboard_plug_user_accounts_widgets_crop_view_in_quad (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                   gint qx,
                                                                   gint qy,
                                                                   gint qw,
                                                                   gint qh,
                                                                   gint x,
                                                                   gint y);
static void switchboard_plug_user_accounts_widgets_crop_view_apply_cursor (SwitchboardPlugUserAccountsWidgetsCropView* self);
static gint switchboard_plug_user_accounts_widgets_crop_view_x_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                   gint ax);
static gint switchboard_plug_user_accounts_widgets_crop_view_y_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                   gint ay);
static gint switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                       gint aw,
                                                                       gint ax);
static gint switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                        gint ah,
                                                                        gint ay);
static gboolean switchboard_plug_user_accounts_widgets_crop_view_real_button_release_event (GtkWidget* base,
                                                                                     GdkEventButton* event);
static gboolean switchboard_plug_user_accounts_widgets_crop_view_real_draw (GtkWidget* base,
                                                                     cairo_t* cr);
static void switchboard_plug_user_accounts_widgets_crop_view_finalize (GObject * obj);
static GType switchboard_plug_user_accounts_widgets_crop_view_get_type_once (void);
static void _vala_switchboard_plug_user_accounts_widgets_crop_view_get_property (GObject * object,
                                                                          guint property_id,
                                                                          GValue * value,
                                                                          GParamSpec * pspec);
static void _vala_switchboard_plug_user_accounts_widgets_crop_view_set_property (GObject * object,
                                                                          guint property_id,
                                                                          const GValue * value,
                                                                          GParamSpec * pspec);

static inline gpointer
switchboard_plug_user_accounts_widgets_crop_view_get_instance_private (SwitchboardPlugUserAccountsWidgetsCropView* self)
{
	return G_STRUCT_MEMBER_P (self, SwitchboardPlugUserAccountsWidgetsCropView_private_offset);
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_construct_from_pixbuf (GType object_type,
                                                                        GdkPixbuf* pixbuf)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self = NULL;
#line 119 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 119 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) g_object_new (object_type, NULL);
#line 120 "../src/Widgets/CropView.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_POINTER_MOTION_MASK | GDK_BUTTON_MOTION_MASK));
#line 121 "../src/Widgets/CropView.vala"
	switchboard_plug_user_accounts_widgets_crop_view_set_pixbuf (self, pixbuf);
#line 123 "../src/Widgets/CropView.vala"
	if (gdk_pixbuf_get_width (pixbuf) > gdk_pixbuf_get_height (pixbuf)) {
#line 128 "CropView.c"
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
		GdkRectangle _tmp2_ = {0};
#line 124 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->_pixbuf;
#line 124 "../src/Widgets/CropView.vala"
		_tmp1_ = self->priv->_pixbuf;
#line 124 "../src/Widgets/CropView.vala"
		_tmp2_.x = 5;
#line 124 "../src/Widgets/CropView.vala"
		_tmp2_.y = 5;
#line 124 "../src/Widgets/CropView.vala"
		_tmp2_.width = gdk_pixbuf_get_height (_tmp0_) / 2;
#line 124 "../src/Widgets/CropView.vala"
		_tmp2_.height = gdk_pixbuf_get_height (_tmp1_) / 2;
#line 124 "../src/Widgets/CropView.vala"
		self->priv->area = _tmp2_;
#line 146 "CropView.c"
	} else {
#line 125 "../src/Widgets/CropView.vala"
		if (gdk_pixbuf_get_width (pixbuf) < gdk_pixbuf_get_height (pixbuf)) {
#line 150 "CropView.c"
			GdkRectangle _tmp3_ = {0};
#line 126 "../src/Widgets/CropView.vala"
			_tmp3_.x = 5;
#line 126 "../src/Widgets/CropView.vala"
			_tmp3_.y = 5;
#line 126 "../src/Widgets/CropView.vala"
			_tmp3_.width = gdk_pixbuf_get_width (pixbuf) / 2;
#line 126 "../src/Widgets/CropView.vala"
			_tmp3_.height = gdk_pixbuf_get_width (pixbuf) / 2;
#line 126 "../src/Widgets/CropView.vala"
			self->priv->area = _tmp3_;
#line 162 "CropView.c"
		} else {
			GdkRectangle _tmp4_ = {0};
#line 128 "../src/Widgets/CropView.vala"
			_tmp4_.x = 5;
#line 128 "../src/Widgets/CropView.vala"
			_tmp4_.y = 5;
#line 128 "../src/Widgets/CropView.vala"
			_tmp4_.width = gdk_pixbuf_get_width (pixbuf) / 2;
#line 128 "../src/Widgets/CropView.vala"
			_tmp4_.height = gdk_pixbuf_get_height (pixbuf) / 2;
#line 128 "../src/Widgets/CropView.vala"
			self->priv->area = _tmp4_;
#line 175 "CropView.c"
		}
	}
#line 119 "../src/Widgets/CropView.vala"
	return self;
#line 180 "CropView.c"
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_new_from_pixbuf (GdkPixbuf* pixbuf)
{
#line 119 "../src/Widgets/CropView.vala"
	return switchboard_plug_user_accounts_widgets_crop_view_construct_from_pixbuf (SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, pixbuf);
#line 188 "CropView.c"
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_construct_from_pixbuf_with_size (GType object_type,
                                                                                  GdkPixbuf* pixbuf,
                                                                                  gint x,
                                                                                  gint y,
                                                                                  gboolean quadratic_selection)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self = NULL;
#line 132 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 132 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) g_object_new (object_type, NULL);
#line 133 "../src/Widgets/CropView.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_POINTER_MOTION_MASK | GDK_BUTTON_MOTION_MASK));
#line 134 "../src/Widgets/CropView.vala"
	switchboard_plug_user_accounts_widgets_crop_view_set_pixbuf (self, pixbuf);
#line 135 "../src/Widgets/CropView.vala"
	self->quadratic_selection = quadratic_selection;
#line 137 "../src/Widgets/CropView.vala"
	if (gdk_pixbuf_get_width (pixbuf) > gdk_pixbuf_get_height (pixbuf)) {
#line 211 "CropView.c"
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
		GdkRectangle _tmp2_ = {0};
		gdouble temp_scale = 0.0;
#line 138 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->_pixbuf;
#line 138 "../src/Widgets/CropView.vala"
		_tmp1_ = self->priv->_pixbuf;
#line 138 "../src/Widgets/CropView.vala"
		_tmp2_.x = 5;
#line 138 "../src/Widgets/CropView.vala"
		_tmp2_.y = 5;
#line 138 "../src/Widgets/CropView.vala"
		_tmp2_.width = gdk_pixbuf_get_height (_tmp0_) / 2;
#line 138 "../src/Widgets/CropView.vala"
		_tmp2_.height = gdk_pixbuf_get_height (_tmp1_) / 2;
#line 138 "../src/Widgets/CropView.vala"
		self->priv->area = _tmp2_;
#line 140 "../src/Widgets/CropView.vala"
		temp_scale = ((gdouble) x) / ((gdouble) gdk_pixbuf_get_width (pixbuf));
#line 141 "../src/Widgets/CropView.vala"
		if ((gdk_pixbuf_get_height (pixbuf) * temp_scale) < ((gdouble) y)) {
#line 142 "../src/Widgets/CropView.vala"
			y = (gint) (gdk_pixbuf_get_height (pixbuf) * temp_scale);
#line 236 "CropView.c"
		}
	} else {
#line 143 "../src/Widgets/CropView.vala"
		if (gdk_pixbuf_get_width (pixbuf) < gdk_pixbuf_get_height (pixbuf)) {
#line 241 "CropView.c"
			GdkPixbuf* _tmp3_;
			GdkRectangle _tmp4_ = {0};
			gdouble temp_scale = 0.0;
#line 144 "../src/Widgets/CropView.vala"
			_tmp3_ = self->priv->_pixbuf;
#line 144 "../src/Widgets/CropView.vala"
			_tmp4_.x = 5;
#line 144 "../src/Widgets/CropView.vala"
			_tmp4_.y = 5;
#line 144 "../src/Widgets/CropView.vala"
			_tmp4_.width = gdk_pixbuf_get_width (_tmp3_) / 2;
#line 144 "../src/Widgets/CropView.vala"
			_tmp4_.height = gdk_pixbuf_get_width (pixbuf) / 2;
#line 144 "../src/Widgets/CropView.vala"
			self->priv->area = _tmp4_;
#line 146 "../src/Widgets/CropView.vala"
			temp_scale = ((gdouble) y) / ((gdouble) gdk_pixbuf_get_height (pixbuf));
#line 147 "../src/Widgets/CropView.vala"
			if ((gdk_pixbuf_get_width (pixbuf) * temp_scale) < ((gdouble) x)) {
#line 148 "../src/Widgets/CropView.vala"
				x = (gint) (gdk_pixbuf_get_width (pixbuf) * temp_scale);
#line 263 "CropView.c"
			}
		} else {
			GdkPixbuf* _tmp5_;
			GdkRectangle _tmp6_ = {0};
#line 150 "../src/Widgets/CropView.vala"
			_tmp5_ = self->priv->_pixbuf;
#line 150 "../src/Widgets/CropView.vala"
			_tmp6_.x = 5;
#line 150 "../src/Widgets/CropView.vala"
			_tmp6_.y = 5;
#line 150 "../src/Widgets/CropView.vala"
			_tmp6_.width = gdk_pixbuf_get_width (_tmp5_) / 2;
#line 150 "../src/Widgets/CropView.vala"
			_tmp6_.height = gdk_pixbuf_get_height (pixbuf) / 2;
#line 150 "../src/Widgets/CropView.vala"
			self->priv->area = _tmp6_;
#line 280 "CropView.c"
		}
	}
#line 152 "../src/Widgets/CropView.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, x, y);
#line 132 "../src/Widgets/CropView.vala"
	return self;
#line 287 "CropView.c"
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_new_from_pixbuf_with_size (GdkPixbuf* pixbuf,
                                                                            gint x,
                                                                            gint y,
                                                                            gboolean quadratic_selection)
{
#line 132 "../src/Widgets/CropView.vala"
	return switchboard_plug_user_accounts_widgets_crop_view_construct_from_pixbuf_with_size (SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, pixbuf, x, y, quadratic_selection);
#line 298 "CropView.c"
}

/**
         * returns the current selected area as pixbuf
         */
GdkPixbuf*
switchboard_plug_user_accounts_widgets_crop_view_get_selection (SwitchboardPlugUserAccountsWidgetsCropView* self)
{
	GdkPixbuf* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* result;
#line 158 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "../src/Widgets/CropView.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 159 "../src/Widgets/CropView.vala"
	_tmp1_ = self->priv->area;
#line 159 "../src/Widgets/CropView.vala"
	_tmp2_ = self->priv->area;
#line 159 "../src/Widgets/CropView.vala"
	_tmp3_ = self->priv->area;
#line 159 "../src/Widgets/CropView.vala"
	_tmp4_ = self->priv->area;
#line 159 "../src/Widgets/CropView.vala"
	_tmp5_ = gdk_pixbuf_new_subpixbuf (_tmp0_, _tmp1_.x, _tmp2_.y, _tmp3_.width, _tmp4_.height);
#line 159 "../src/Widgets/CropView.vala"
	result = _tmp5_;
#line 159 "../src/Widgets/CropView.vala"
	return result;
#line 332 "CropView.c"
}

static gboolean
switchboard_plug_user_accounts_widgets_crop_view_real_button_press_event (GtkWidget* base,
                                                                          GdkEventButton* event)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	gboolean result;
#line 162 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) base;
#line 162 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 163 "../src/Widgets/CropView.vala"
	self->priv->mouse_button_down = TRUE;
#line 164 "../src/Widgets/CropView.vala"
	self->priv->temp_x = (gint) event->x;
#line 165 "../src/Widgets/CropView.vala"
	self->priv->temp_y = (gint) event->y;
#line 167 "../src/Widgets/CropView.vala"
	result = TRUE;
#line 167 "../src/Widgets/CropView.vala"
	return result;
#line 355 "CropView.c"
}

static gboolean
switchboard_plug_user_accounts_widgets_crop_view_real_motion_notify_event (GtkWidget* base,
                                                                           GdkEventMotion* event)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	gboolean result;
#line 170 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) base;
#line 170 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 171 "../src/Widgets/CropView.vala"
	if (!self->priv->mouse_button_down) {
#line 370 "CropView.c"
		gboolean determined_cursortype = FALSE;
#line 174 "../src/Widgets/CropView.vala"
		static const GdkCursorType CURSOR[8] = {GDK_TOP_LEFT_CORNER, GDK_TOP_SIDE, GDK_TOP_RIGHT_CORNER, GDK_RIGHT_SIDE, GDK_BOTTOM_RIGHT_CORNER, GDK_BOTTOM_SIDE, GDK_BOTTOM_LEFT_CORNER, GDK_LEFT_SIDE};
#line 172 "../src/Widgets/CropView.vala"
		determined_cursortype = FALSE;
#line 376 "CropView.c"
		{
			gint i = 0;
#line 185 "../src/Widgets/CropView.vala"
			i = 0;
#line 381 "CropView.c"
			{
				gboolean _tmp0_ = FALSE;
#line 185 "../src/Widgets/CropView.vala"
				_tmp0_ = TRUE;
#line 185 "../src/Widgets/CropView.vala"
				while (TRUE) {
#line 388 "CropView.c"
					gint* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					gint _tmp3_;
					gint* _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					gint _tmp5_;
#line 185 "../src/Widgets/CropView.vala"
					if (!_tmp0_) {
#line 399 "CropView.c"
						gint _tmp1_;
#line 185 "../src/Widgets/CropView.vala"
						_tmp1_ = i;
#line 185 "../src/Widgets/CropView.vala"
						i = _tmp1_ + 1;
#line 405 "CropView.c"
					}
#line 185 "../src/Widgets/CropView.vala"
					_tmp0_ = FALSE;
#line 185 "../src/Widgets/CropView.vala"
					if (!(i < 8)) {
#line 185 "../src/Widgets/CropView.vala"
						break;
#line 413 "CropView.c"
					}
#line 186 "../src/Widgets/CropView.vala"
					_tmp2_ = self->priv->pos;
#line 186 "../src/Widgets/CropView.vala"
					_tmp2__length1 = self->priv->pos_length1;
#line 186 "../src/Widgets/CropView.vala"
					_tmp2__length2 = self->priv->pos_length2;
#line 186 "../src/Widgets/CropView.vala"
					_tmp3_ = _tmp2_[(i * _tmp2__length2) + 0];
#line 186 "../src/Widgets/CropView.vala"
					_tmp4_ = self->priv->pos;
#line 186 "../src/Widgets/CropView.vala"
					_tmp4__length1 = self->priv->pos_length1;
#line 186 "../src/Widgets/CropView.vala"
					_tmp4__length2 = self->priv->pos_length2;
#line 186 "../src/Widgets/CropView.vala"
					_tmp5_ = _tmp4_[(i * _tmp4__length2) + 1];
#line 186 "../src/Widgets/CropView.vala"
					if (switchboard_plug_user_accounts_widgets_crop_view_in_quad (self, _tmp3_ - SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS, _tmp5_ - SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS, SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS * 2, SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS * 2, (gint) event->x, (gint) event->y)) {
#line 433 "CropView.c"
						GdkCursorType _tmp6_;
#line 187 "../src/Widgets/CropView.vala"
						_tmp6_ = CURSOR[i];
#line 187 "../src/Widgets/CropView.vala"
						self->priv->current_operation = _tmp6_;
#line 188 "../src/Widgets/CropView.vala"
						determined_cursortype = TRUE;
#line 189 "../src/Widgets/CropView.vala"
						break;
#line 443 "CropView.c"
					}
				}
			}
		}
#line 193 "../src/Widgets/CropView.vala"
		if (!determined_cursortype) {
#line 450 "CropView.c"
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
#line 194 "../src/Widgets/CropView.vala"
			_tmp7_ = self->priv->area;
#line 194 "../src/Widgets/CropView.vala"
			_tmp8_ = self->priv->area;
#line 194 "../src/Widgets/CropView.vala"
			_tmp9_ = self->priv->area;
#line 194 "../src/Widgets/CropView.vala"
			_tmp10_ = self->priv->area;
#line 194 "../src/Widgets/CropView.vala"
			if (switchboard_plug_user_accounts_widgets_crop_view_in_quad (self, (gint) floor (_tmp7_.x * self->priv->current_scale), (gint) floor (_tmp8_.y * self->priv->current_scale), (gint) floor (_tmp9_.width * self->priv->current_scale), (gint) floor (_tmp10_.height * self->priv->current_scale), (gint) (event->x - self->priv->offset_x), (gint) (event->y - self->priv->offset_y))) {
#line 199 "../src/Widgets/CropView.vala"
				self->priv->current_operation = GDK_FLEUR;
#line 467 "CropView.c"
			} else {
#line 201 "../src/Widgets/CropView.vala"
				self->priv->current_operation = GDK_ARROW;
#line 471 "CropView.c"
			}
		}
#line 204 "../src/Widgets/CropView.vala"
		switchboard_plug_user_accounts_widgets_crop_view_apply_cursor (self);
#line 205 "../src/Widgets/CropView.vala"
		result = TRUE;
#line 205 "../src/Widgets/CropView.vala"
		return result;
#line 480 "CropView.c"
	} else {
		GdkRectangle _tmp65_;
		GdkRectangle _tmp66_;
#line 208 "../src/Widgets/CropView.vala"
		switch (self->priv->current_operation) {
#line 208 "../src/Widgets/CropView.vala"
			case GDK_FLEUR:
#line 488 "CropView.c"
			{
				gint motion_x = 0;
				GdkRectangle _tmp11_;
				gint motion_y = 0;
				GdkRectangle _tmp12_;
#line 210 "../src/Widgets/CropView.vala"
				_tmp11_ = self->priv->area;
#line 210 "../src/Widgets/CropView.vala"
				motion_x = (gint) (_tmp11_.x + ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 211 "../src/Widgets/CropView.vala"
				_tmp12_ = self->priv->area;
#line 211 "../src/Widgets/CropView.vala"
				motion_y = (gint) (_tmp12_.y + ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 213 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_x_in_pixbuf (self, motion_x)) {
#line 213 "../src/Widgets/CropView.vala"
					case 0:
#line 506 "CropView.c"
					{
#line 214 "../src/Widgets/CropView.vala"
						self->priv->area.x = motion_x;
#line 214 "../src/Widgets/CropView.vala"
						g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 214 "../src/Widgets/CropView.vala"
						break;
#line 514 "CropView.c"
					}
#line 213 "../src/Widgets/CropView.vala"
					case 1:
#line 518 "CropView.c"
					{
#line 215 "../src/Widgets/CropView.vala"
						self->priv->area.x = 0;
#line 215 "../src/Widgets/CropView.vala"
						break;
#line 524 "CropView.c"
					}
#line 213 "../src/Widgets/CropView.vala"
					case 2:
#line 528 "CropView.c"
					{
						GdkPixbuf* _tmp13_;
						GdkRectangle _tmp14_;
#line 216 "../src/Widgets/CropView.vala"
						_tmp13_ = self->priv->_pixbuf;
#line 216 "../src/Widgets/CropView.vala"
						_tmp14_ = self->priv->area;
#line 216 "../src/Widgets/CropView.vala"
						self->priv->area.x = gdk_pixbuf_get_width (_tmp13_) - _tmp14_.width;
#line 216 "../src/Widgets/CropView.vala"
						break;
#line 540 "CropView.c"
					}
					default:
#line 213 "../src/Widgets/CropView.vala"
					break;
#line 545 "CropView.c"
				}
#line 219 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_y_in_pixbuf (self, motion_y)) {
#line 219 "../src/Widgets/CropView.vala"
					case 0:
#line 551 "CropView.c"
					{
#line 220 "../src/Widgets/CropView.vala"
						self->priv->area.y = motion_y;
#line 220 "../src/Widgets/CropView.vala"
						g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 220 "../src/Widgets/CropView.vala"
						break;
#line 559 "CropView.c"
					}
#line 219 "../src/Widgets/CropView.vala"
					case 1:
#line 563 "CropView.c"
					{
#line 221 "../src/Widgets/CropView.vala"
						self->priv->area.y = 0;
#line 221 "../src/Widgets/CropView.vala"
						break;
#line 569 "CropView.c"
					}
#line 219 "../src/Widgets/CropView.vala"
					case 2:
#line 573 "CropView.c"
					{
						GdkPixbuf* _tmp15_;
						GdkRectangle _tmp16_;
#line 222 "../src/Widgets/CropView.vala"
						_tmp15_ = self->priv->_pixbuf;
#line 222 "../src/Widgets/CropView.vala"
						_tmp16_ = self->priv->area;
#line 222 "../src/Widgets/CropView.vala"
						self->priv->area.y = gdk_pixbuf_get_height (_tmp15_) - _tmp16_.height;
#line 222 "../src/Widgets/CropView.vala"
						break;
#line 585 "CropView.c"
					}
					default:
#line 219 "../src/Widgets/CropView.vala"
					break;
#line 590 "CropView.c"
				}
#line 225 "../src/Widgets/CropView.vala"
				break;
#line 594 "CropView.c"
			}
#line 208 "../src/Widgets/CropView.vala"
			case GDK_TOP_RIGHT_CORNER:
#line 208 "../src/Widgets/CropView.vala"
			case GDK_TOP_LEFT_CORNER:
#line 600 "CropView.c"
			{
				gint motion_width = 0;
				gint motion_height = 0;
				gboolean _tmp21_ = FALSE;
				GdkRectangle _tmp23_;
				GdkRectangle _tmp27_;
#line 229 "../src/Widgets/CropView.vala"
				motion_width = 0;
#line 230 "../src/Widgets/CropView.vala"
				motion_height = 0;
#line 231 "../src/Widgets/CropView.vala"
				if (self->priv->current_operation == GDK_TOP_RIGHT_CORNER) {
#line 613 "CropView.c"
					GdkRectangle _tmp17_;
					GdkRectangle _tmp18_;
#line 232 "../src/Widgets/CropView.vala"
					_tmp17_ = self->priv->area;
#line 232 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp17_.width + ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 233 "../src/Widgets/CropView.vala"
					_tmp18_ = self->priv->area;
#line 233 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp18_.height - ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 624 "CropView.c"
				} else {
					GdkRectangle _tmp19_;
					GdkRectangle _tmp20_;
#line 236 "../src/Widgets/CropView.vala"
					_tmp19_ = self->priv->area;
#line 236 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp19_.width - ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 237 "../src/Widgets/CropView.vala"
					_tmp20_ = self->priv->area;
#line 237 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp20_.height - ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 636 "CropView.c"
				}
#line 240 "../src/Widgets/CropView.vala"
				if (self->quadratic_selection) {
#line 240 "../src/Widgets/CropView.vala"
					_tmp21_ = motion_width >= motion_height;
#line 642 "CropView.c"
				} else {
#line 240 "../src/Widgets/CropView.vala"
					_tmp21_ = FALSE;
#line 646 "CropView.c"
				}
#line 240 "../src/Widgets/CropView.vala"
				if (_tmp21_) {
#line 241 "../src/Widgets/CropView.vala"
					motion_height = motion_width;
#line 652 "CropView.c"
				} else {
					gboolean _tmp22_ = FALSE;
#line 242 "../src/Widgets/CropView.vala"
					if (self->quadratic_selection) {
#line 242 "../src/Widgets/CropView.vala"
						_tmp22_ = motion_width < motion_height;
#line 659 "CropView.c"
					} else {
#line 242 "../src/Widgets/CropView.vala"
						_tmp22_ = FALSE;
#line 663 "CropView.c"
					}
#line 242 "../src/Widgets/CropView.vala"
					if (_tmp22_) {
#line 243 "../src/Widgets/CropView.vala"
						motion_width = motion_height;
#line 669 "CropView.c"
					}
				}
#line 245 "../src/Widgets/CropView.vala"
				_tmp23_ = self->priv->area;
#line 245 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp23_.x)) {
#line 245 "../src/Widgets/CropView.vala"
					case 0:
#line 678 "CropView.c"
					{
						GdkRectangle _tmp24_;
#line 247 "../src/Widgets/CropView.vala"
						_tmp24_ = self->priv->area;
#line 247 "../src/Widgets/CropView.vala"
						if (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp24_.y) == 0) {
#line 248 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 249 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 250 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 691 "CropView.c"
						}
#line 252 "../src/Widgets/CropView.vala"
						break;
#line 695 "CropView.c"
					}
#line 245 "../src/Widgets/CropView.vala"
					case 1:
#line 699 "CropView.c"
					{
#line 254 "../src/Widgets/CropView.vala"
						self->priv->area.width = 0;
#line 255 "../src/Widgets/CropView.vala"
						break;
#line 705 "CropView.c"
					}
#line 245 "../src/Widgets/CropView.vala"
					case 2:
#line 709 "CropView.c"
					{
						GdkPixbuf* _tmp25_;
						GdkRectangle _tmp26_;
#line 257 "../src/Widgets/CropView.vala"
						_tmp25_ = self->priv->_pixbuf;
#line 257 "../src/Widgets/CropView.vala"
						_tmp26_ = self->priv->area;
#line 257 "../src/Widgets/CropView.vala"
						self->priv->area.width = gdk_pixbuf_get_width (_tmp25_) - _tmp26_.x;
#line 258 "../src/Widgets/CropView.vala"
						break;
#line 721 "CropView.c"
					}
					default:
#line 245 "../src/Widgets/CropView.vala"
					break;
#line 726 "CropView.c"
				}
#line 261 "../src/Widgets/CropView.vala"
				_tmp27_ = self->priv->area;
#line 261 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp27_.y)) {
#line 261 "../src/Widgets/CropView.vala"
					case 0:
#line 734 "CropView.c"
					{
						GdkRectangle _tmp28_;
#line 263 "../src/Widgets/CropView.vala"
						_tmp28_ = self->priv->area;
#line 263 "../src/Widgets/CropView.vala"
						if (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp28_.x) == 0) {
#line 264 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 265 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 266 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 747 "CropView.c"
						}
#line 268 "../src/Widgets/CropView.vala"
						break;
#line 751 "CropView.c"
					}
#line 261 "../src/Widgets/CropView.vala"
					case 1:
#line 755 "CropView.c"
					{
#line 270 "../src/Widgets/CropView.vala"
						self->priv->area.height = 0;
#line 271 "../src/Widgets/CropView.vala"
						break;
#line 761 "CropView.c"
					}
#line 261 "../src/Widgets/CropView.vala"
					case 2:
#line 765 "CropView.c"
					{
						GdkPixbuf* _tmp29_;
						GdkRectangle _tmp30_;
#line 273 "../src/Widgets/CropView.vala"
						_tmp29_ = self->priv->_pixbuf;
#line 273 "../src/Widgets/CropView.vala"
						_tmp30_ = self->priv->area;
#line 273 "../src/Widgets/CropView.vala"
						self->priv->area.height = gdk_pixbuf_get_height (_tmp29_) - _tmp30_.y;
#line 274 "../src/Widgets/CropView.vala"
						break;
#line 777 "CropView.c"
					}
					default:
#line 261 "../src/Widgets/CropView.vala"
					break;
#line 782 "CropView.c"
				}
#line 277 "../src/Widgets/CropView.vala"
				break;
#line 786 "CropView.c"
			}
#line 208 "../src/Widgets/CropView.vala"
			case GDK_BOTTOM_RIGHT_CORNER:
#line 208 "../src/Widgets/CropView.vala"
			case GDK_BOTTOM_LEFT_CORNER:
#line 792 "CropView.c"
			{
				gint motion_width = 0;
				gint motion_height = 0;
				gboolean _tmp35_ = FALSE;
				GdkRectangle _tmp37_;
				GdkRectangle _tmp41_;
#line 281 "../src/Widgets/CropView.vala"
				motion_width = 0;
#line 282 "../src/Widgets/CropView.vala"
				motion_height = 0;
#line 283 "../src/Widgets/CropView.vala"
				if (self->priv->current_operation == GDK_BOTTOM_RIGHT_CORNER) {
#line 805 "CropView.c"
					GdkRectangle _tmp31_;
					GdkRectangle _tmp32_;
#line 284 "../src/Widgets/CropView.vala"
					_tmp31_ = self->priv->area;
#line 284 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp31_.width + ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 285 "../src/Widgets/CropView.vala"
					_tmp32_ = self->priv->area;
#line 285 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp32_.height + ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 816 "CropView.c"
				} else {
					GdkRectangle _tmp33_;
					GdkRectangle _tmp34_;
#line 288 "../src/Widgets/CropView.vala"
					_tmp33_ = self->priv->area;
#line 288 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp33_.width - ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 289 "../src/Widgets/CropView.vala"
					_tmp34_ = self->priv->area;
#line 289 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp34_.height + ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 828 "CropView.c"
				}
#line 292 "../src/Widgets/CropView.vala"
				if (self->quadratic_selection) {
#line 292 "../src/Widgets/CropView.vala"
					_tmp35_ = motion_width >= motion_height;
#line 834 "CropView.c"
				} else {
#line 292 "../src/Widgets/CropView.vala"
					_tmp35_ = FALSE;
#line 838 "CropView.c"
				}
#line 292 "../src/Widgets/CropView.vala"
				if (_tmp35_) {
#line 293 "../src/Widgets/CropView.vala"
					motion_height = motion_width;
#line 844 "CropView.c"
				} else {
					gboolean _tmp36_ = FALSE;
#line 294 "../src/Widgets/CropView.vala"
					if (self->quadratic_selection) {
#line 294 "../src/Widgets/CropView.vala"
						_tmp36_ = motion_width < motion_height;
#line 851 "CropView.c"
					} else {
#line 294 "../src/Widgets/CropView.vala"
						_tmp36_ = FALSE;
#line 855 "CropView.c"
					}
#line 294 "../src/Widgets/CropView.vala"
					if (_tmp36_) {
#line 295 "../src/Widgets/CropView.vala"
						motion_width = motion_height;
#line 861 "CropView.c"
					}
				}
#line 297 "../src/Widgets/CropView.vala"
				_tmp37_ = self->priv->area;
#line 297 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp37_.x)) {
#line 297 "../src/Widgets/CropView.vala"
					case 0:
#line 870 "CropView.c"
					{
						GdkRectangle _tmp38_;
#line 299 "../src/Widgets/CropView.vala"
						_tmp38_ = self->priv->area;
#line 299 "../src/Widgets/CropView.vala"
						if (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp38_.y) == 0) {
#line 300 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 301 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 302 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 883 "CropView.c"
						}
#line 304 "../src/Widgets/CropView.vala"
						break;
#line 887 "CropView.c"
					}
#line 297 "../src/Widgets/CropView.vala"
					case 1:
#line 891 "CropView.c"
					{
#line 306 "../src/Widgets/CropView.vala"
						self->priv->area.width = 0;
#line 307 "../src/Widgets/CropView.vala"
						break;
#line 897 "CropView.c"
					}
#line 297 "../src/Widgets/CropView.vala"
					case 2:
#line 901 "CropView.c"
					{
						GdkPixbuf* _tmp39_;
						GdkRectangle _tmp40_;
#line 309 "../src/Widgets/CropView.vala"
						_tmp39_ = self->priv->_pixbuf;
#line 309 "../src/Widgets/CropView.vala"
						_tmp40_ = self->priv->area;
#line 309 "../src/Widgets/CropView.vala"
						self->priv->area.width = gdk_pixbuf_get_width (_tmp39_) - _tmp40_.x;
#line 310 "../src/Widgets/CropView.vala"
						break;
#line 913 "CropView.c"
					}
					default:
#line 297 "../src/Widgets/CropView.vala"
					break;
#line 918 "CropView.c"
				}
#line 313 "../src/Widgets/CropView.vala"
				_tmp41_ = self->priv->area;
#line 313 "../src/Widgets/CropView.vala"
				switch (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp41_.y)) {
#line 313 "../src/Widgets/CropView.vala"
					case 0:
#line 926 "CropView.c"
					{
						GdkRectangle _tmp42_;
#line 315 "../src/Widgets/CropView.vala"
						_tmp42_ = self->priv->area;
#line 315 "../src/Widgets/CropView.vala"
						if (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp42_.x) == 0) {
#line 316 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 317 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 318 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 939 "CropView.c"
						}
#line 320 "../src/Widgets/CropView.vala"
						break;
#line 943 "CropView.c"
					}
#line 313 "../src/Widgets/CropView.vala"
					case 1:
#line 947 "CropView.c"
					{
#line 322 "../src/Widgets/CropView.vala"
						self->priv->area.height = 0;
#line 323 "../src/Widgets/CropView.vala"
						break;
#line 953 "CropView.c"
					}
#line 313 "../src/Widgets/CropView.vala"
					case 2:
#line 957 "CropView.c"
					{
						GdkPixbuf* _tmp43_;
						GdkRectangle _tmp44_;
#line 325 "../src/Widgets/CropView.vala"
						_tmp43_ = self->priv->_pixbuf;
#line 325 "../src/Widgets/CropView.vala"
						_tmp44_ = self->priv->area;
#line 325 "../src/Widgets/CropView.vala"
						self->priv->area.height = gdk_pixbuf_get_height (_tmp43_) - _tmp44_.y;
#line 326 "../src/Widgets/CropView.vala"
						break;
#line 969 "CropView.c"
					}
					default:
#line 313 "../src/Widgets/CropView.vala"
					break;
#line 974 "CropView.c"
				}
#line 329 "../src/Widgets/CropView.vala"
				break;
#line 978 "CropView.c"
			}
#line 208 "../src/Widgets/CropView.vala"
			case GDK_TOP_SIDE:
#line 208 "../src/Widgets/CropView.vala"
			case GDK_BOTTOM_SIDE:
#line 984 "CropView.c"
			{
				gint motion_height = 0;
#line 333 "../src/Widgets/CropView.vala"
				motion_height = 0;
#line 334 "../src/Widgets/CropView.vala"
				if (self->priv->current_operation == GDK_BOTTOM_SIDE) {
#line 991 "CropView.c"
					GdkRectangle _tmp45_;
#line 335 "../src/Widgets/CropView.vala"
					_tmp45_ = self->priv->area;
#line 335 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp45_.height + ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 997 "CropView.c"
				} else {
					GdkRectangle _tmp46_;
#line 337 "../src/Widgets/CropView.vala"
					_tmp46_ = self->priv->area;
#line 337 "../src/Widgets/CropView.vala"
					motion_height = (gint) (_tmp46_.height - ((((gint) event->y) - self->priv->temp_y) / self->priv->current_scale));
#line 1004 "CropView.c"
				}
#line 339 "../src/Widgets/CropView.vala"
				if (!self->quadratic_selection) {
#line 1008 "CropView.c"
					GdkRectangle _tmp47_;
#line 340 "../src/Widgets/CropView.vala"
					_tmp47_ = self->priv->area;
#line 340 "../src/Widgets/CropView.vala"
					switch (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp47_.y)) {
#line 340 "../src/Widgets/CropView.vala"
						case 0:
#line 1016 "CropView.c"
						{
#line 341 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 341 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 341 "../src/Widgets/CropView.vala"
							break;
#line 1024 "CropView.c"
						}
#line 340 "../src/Widgets/CropView.vala"
						case 1:
#line 1028 "CropView.c"
						{
#line 342 "../src/Widgets/CropView.vala"
							self->priv->area.height = 0;
#line 342 "../src/Widgets/CropView.vala"
							break;
#line 1034 "CropView.c"
						}
#line 340 "../src/Widgets/CropView.vala"
						case 2:
#line 1038 "CropView.c"
						{
							GdkPixbuf* _tmp48_;
							GdkRectangle _tmp49_;
#line 343 "../src/Widgets/CropView.vala"
							_tmp48_ = self->priv->_pixbuf;
#line 343 "../src/Widgets/CropView.vala"
							_tmp49_ = self->priv->area;
#line 343 "../src/Widgets/CropView.vala"
							self->priv->area.height = gdk_pixbuf_get_height (_tmp48_) - _tmp49_.y;
#line 343 "../src/Widgets/CropView.vala"
							break;
#line 1050 "CropView.c"
						}
						default:
#line 340 "../src/Widgets/CropView.vala"
						break;
#line 1055 "CropView.c"
					}
				} else {
					GdkRectangle _tmp50_;
#line 347 "../src/Widgets/CropView.vala"
					_tmp50_ = self->priv->area;
#line 347 "../src/Widgets/CropView.vala"
					switch (switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (self, motion_height, _tmp50_.y)) {
#line 347 "../src/Widgets/CropView.vala"
						case 0:
#line 1065 "CropView.c"
						{
#line 349 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_height;
#line 350 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_height;
#line 351 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 352 "../src/Widgets/CropView.vala"
							break;
#line 1075 "CropView.c"
						}
#line 347 "../src/Widgets/CropView.vala"
						case 1:
#line 1079 "CropView.c"
						{
#line 354 "../src/Widgets/CropView.vala"
							self->priv->area.width = 0;
#line 355 "../src/Widgets/CropView.vala"
							self->priv->area.height = 0;
#line 356 "../src/Widgets/CropView.vala"
							break;
#line 1087 "CropView.c"
						}
#line 347 "../src/Widgets/CropView.vala"
						case 2:
#line 1091 "CropView.c"
						{
							GdkPixbuf* _tmp51_;
							GdkRectangle _tmp52_;
							GdkPixbuf* _tmp53_;
							GdkRectangle _tmp54_;
#line 358 "../src/Widgets/CropView.vala"
							_tmp51_ = self->priv->_pixbuf;
#line 358 "../src/Widgets/CropView.vala"
							_tmp52_ = self->priv->area;
#line 358 "../src/Widgets/CropView.vala"
							self->priv->area.width = gdk_pixbuf_get_width (_tmp51_) - _tmp52_.x;
#line 359 "../src/Widgets/CropView.vala"
							_tmp53_ = self->priv->_pixbuf;
#line 359 "../src/Widgets/CropView.vala"
							_tmp54_ = self->priv->area;
#line 359 "../src/Widgets/CropView.vala"
							self->priv->area.height = gdk_pixbuf_get_height (_tmp53_) - _tmp54_.y;
#line 360 "../src/Widgets/CropView.vala"
							break;
#line 1111 "CropView.c"
						}
						default:
#line 347 "../src/Widgets/CropView.vala"
						break;
#line 1116 "CropView.c"
					}
				}
#line 363 "../src/Widgets/CropView.vala"
				break;
#line 1121 "CropView.c"
			}
#line 208 "../src/Widgets/CropView.vala"
			case GDK_RIGHT_SIDE:
#line 208 "../src/Widgets/CropView.vala"
			case GDK_LEFT_SIDE:
#line 1127 "CropView.c"
			{
				gint motion_width = 0;
#line 367 "../src/Widgets/CropView.vala"
				motion_width = 0;
#line 368 "../src/Widgets/CropView.vala"
				if (self->priv->current_operation == GDK_RIGHT_SIDE) {
#line 1134 "CropView.c"
					GdkRectangle _tmp55_;
#line 369 "../src/Widgets/CropView.vala"
					_tmp55_ = self->priv->area;
#line 369 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp55_.width + ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 1140 "CropView.c"
				} else {
					GdkRectangle _tmp56_;
#line 371 "../src/Widgets/CropView.vala"
					_tmp56_ = self->priv->area;
#line 371 "../src/Widgets/CropView.vala"
					motion_width = (gint) (_tmp56_.width - ((((gint) event->x) - self->priv->temp_x) / self->priv->current_scale));
#line 1147 "CropView.c"
				}
#line 373 "../src/Widgets/CropView.vala"
				if (!self->quadratic_selection) {
#line 1151 "CropView.c"
					GdkRectangle _tmp57_;
#line 374 "../src/Widgets/CropView.vala"
					_tmp57_ = self->priv->area;
#line 374 "../src/Widgets/CropView.vala"
					switch (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp57_.x)) {
#line 374 "../src/Widgets/CropView.vala"
						case 0:
#line 1159 "CropView.c"
						{
#line 375 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 375 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 375 "../src/Widgets/CropView.vala"
							break;
#line 1167 "CropView.c"
						}
#line 374 "../src/Widgets/CropView.vala"
						case 1:
#line 1171 "CropView.c"
						{
#line 376 "../src/Widgets/CropView.vala"
							self->priv->area.width = 0;
#line 376 "../src/Widgets/CropView.vala"
							break;
#line 1177 "CropView.c"
						}
#line 374 "../src/Widgets/CropView.vala"
						case 2:
#line 1181 "CropView.c"
						{
							GdkPixbuf* _tmp58_;
							GdkRectangle _tmp59_;
#line 377 "../src/Widgets/CropView.vala"
							_tmp58_ = self->priv->_pixbuf;
#line 377 "../src/Widgets/CropView.vala"
							_tmp59_ = self->priv->area;
#line 377 "../src/Widgets/CropView.vala"
							self->priv->area.width = gdk_pixbuf_get_width (_tmp58_) - _tmp59_.x;
#line 377 "../src/Widgets/CropView.vala"
							break;
#line 1193 "CropView.c"
						}
						default:
#line 374 "../src/Widgets/CropView.vala"
						break;
#line 1198 "CropView.c"
					}
				} else {
					GdkRectangle _tmp60_;
#line 380 "../src/Widgets/CropView.vala"
					_tmp60_ = self->priv->area;
#line 380 "../src/Widgets/CropView.vala"
					switch (switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (self, motion_width, _tmp60_.x)) {
#line 380 "../src/Widgets/CropView.vala"
						case 0:
#line 1208 "CropView.c"
						{
#line 382 "../src/Widgets/CropView.vala"
							self->priv->area.width = motion_width;
#line 383 "../src/Widgets/CropView.vala"
							self->priv->area.height = motion_width;
#line 384 "../src/Widgets/CropView.vala"
							g_signal_emit (self, switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL], 0);
#line 385 "../src/Widgets/CropView.vala"
							break;
#line 1218 "CropView.c"
						}
#line 380 "../src/Widgets/CropView.vala"
						case 1:
#line 1222 "CropView.c"
						{
#line 387 "../src/Widgets/CropView.vala"
							self->priv->area.width = 0;
#line 388 "../src/Widgets/CropView.vala"
							self->priv->area.height = 0;
#line 389 "../src/Widgets/CropView.vala"
							break;
#line 1230 "CropView.c"
						}
#line 380 "../src/Widgets/CropView.vala"
						case 2:
#line 1234 "CropView.c"
						{
							GdkPixbuf* _tmp61_;
							GdkRectangle _tmp62_;
							GdkPixbuf* _tmp63_;
							GdkRectangle _tmp64_;
#line 391 "../src/Widgets/CropView.vala"
							_tmp61_ = self->priv->_pixbuf;
#line 391 "../src/Widgets/CropView.vala"
							_tmp62_ = self->priv->area;
#line 391 "../src/Widgets/CropView.vala"
							self->priv->area.width = gdk_pixbuf_get_width (_tmp61_) - _tmp62_.x;
#line 392 "../src/Widgets/CropView.vala"
							_tmp63_ = self->priv->_pixbuf;
#line 392 "../src/Widgets/CropView.vala"
							_tmp64_ = self->priv->area;
#line 392 "../src/Widgets/CropView.vala"
							self->priv->area.height = gdk_pixbuf_get_height (_tmp63_) - _tmp64_.y;
#line 393 "../src/Widgets/CropView.vala"
							break;
#line 1254 "CropView.c"
						}
						default:
#line 380 "../src/Widgets/CropView.vala"
						break;
#line 1259 "CropView.c"
					}
				}
#line 397 "../src/Widgets/CropView.vala"
				break;
#line 1264 "CropView.c"
			}
			default:
			{
#line 399 "../src/Widgets/CropView.vala"
				break;
#line 1270 "CropView.c"
			}
		}
#line 402 "../src/Widgets/CropView.vala"
		_tmp65_ = self->priv->area;
#line 402 "../src/Widgets/CropView.vala"
		_tmp66_ = self->priv->area;
#line 402 "../src/Widgets/CropView.vala"
		if (_tmp65_.width != _tmp66_.height) {
#line 1279 "CropView.c"
			gint _tmp67_ = 0;
			GdkRectangle _tmp68_;
			GdkRectangle _tmp69_;
			gint smallest = 0;
#line 403 "../src/Widgets/CropView.vala"
			_tmp68_ = self->priv->area;
#line 403 "../src/Widgets/CropView.vala"
			_tmp69_ = self->priv->area;
#line 403 "../src/Widgets/CropView.vala"
			if (_tmp68_.width > _tmp69_.height) {
#line 1290 "CropView.c"
				GdkRectangle _tmp70_;
#line 403 "../src/Widgets/CropView.vala"
				_tmp70_ = self->priv->area;
#line 403 "../src/Widgets/CropView.vala"
				_tmp67_ = _tmp70_.height;
#line 1296 "CropView.c"
			} else {
				GdkRectangle _tmp71_;
#line 403 "../src/Widgets/CropView.vala"
				_tmp71_ = self->priv->area;
#line 403 "../src/Widgets/CropView.vala"
				_tmp67_ = _tmp71_.width;
#line 1303 "CropView.c"
			}
#line 403 "../src/Widgets/CropView.vala"
			smallest = _tmp67_;
#line 404 "../src/Widgets/CropView.vala"
			self->priv->area.width = smallest;
#line 405 "../src/Widgets/CropView.vala"
			self->priv->area.height = smallest;
#line 1311 "CropView.c"
		}
#line 408 "../src/Widgets/CropView.vala"
		self->priv->temp_x = (gint) event->x;
#line 409 "../src/Widgets/CropView.vala"
		self->priv->temp_y = (gint) event->y;
#line 411 "../src/Widgets/CropView.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 1319 "CropView.c"
	}
#line 414 "../src/Widgets/CropView.vala"
	result = TRUE;
#line 414 "../src/Widgets/CropView.vala"
	return result;
#line 1325 "CropView.c"
}

static gboolean
switchboard_plug_user_accounts_widgets_crop_view_real_button_release_event (GtkWidget* base,
                                                                            GdkEventButton* event)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	gboolean result;
#line 417 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) base;
#line 417 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 418 "../src/Widgets/CropView.vala"
	self->priv->current_operation = GDK_ARROW;
#line 419 "../src/Widgets/CropView.vala"
	self->priv->mouse_button_down = FALSE;
#line 420 "../src/Widgets/CropView.vala"
	switchboard_plug_user_accounts_widgets_crop_view_apply_cursor (self);
#line 422 "../src/Widgets/CropView.vala"
	result = TRUE;
#line 422 "../src/Widgets/CropView.vala"
	return result;
#line 1348 "CropView.c"
}

static gboolean
switchboard_plug_user_accounts_widgets_crop_view_real_draw (GtkWidget* base,
                                                            cairo_t* cr)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	gint pixbuf_width = 0;
	GdkPixbuf* _tmp1_;
	gint pixbuf_height = 0;
	GdkPixbuf* _tmp2_;
	gdouble scale = 0.0;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp6_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GtkAllocation _tmp11_;
	GtkAllocation _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* _tmp14_;
	gint x = 0;
	GdkRectangle _tmp15_;
	gint y = 0;
	GdkRectangle _tmp16_;
	gint w = 0;
	GdkRectangle _tmp17_;
	gint h = 0;
	GdkRectangle _tmp18_;
	gint* _tmp19_;
	gboolean result;
#line 425 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) base;
#line 425 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 428 "../src/Widgets/CropView.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 428 "../src/Widgets/CropView.vala"
	alloc = _tmp0_;
#line 430 "../src/Widgets/CropView.vala"
	_tmp1_ = self->priv->_pixbuf;
#line 430 "../src/Widgets/CropView.vala"
	pixbuf_width = gdk_pixbuf_get_width (_tmp1_);
#line 431 "../src/Widgets/CropView.vala"
	_tmp2_ = self->priv->_pixbuf;
#line 431 "../src/Widgets/CropView.vala"
	pixbuf_height = gdk_pixbuf_get_height (_tmp2_);
#line 432 "../src/Widgets/CropView.vala"
	scale = 1.0;
#line 434 "../src/Widgets/CropView.vala"
	_tmp3_ = alloc;
#line 434 "../src/Widgets/CropView.vala"
	if (pixbuf_width > _tmp3_.width) {
#line 1404 "CropView.c"
		GtkAllocation _tmp4_;
		GtkAllocation _tmp5_;
#line 435 "../src/Widgets/CropView.vala"
		_tmp4_ = alloc;
#line 435 "../src/Widgets/CropView.vala"
		scale = _tmp4_.width / ((gdouble) pixbuf_width);
#line 436 "../src/Widgets/CropView.vala"
		pixbuf_height = (gint) floor (scale * pixbuf_height);
#line 437 "../src/Widgets/CropView.vala"
		_tmp5_ = alloc;
#line 437 "../src/Widgets/CropView.vala"
		pixbuf_width = _tmp5_.width;
#line 1417 "CropView.c"
	}
#line 440 "../src/Widgets/CropView.vala"
	_tmp6_ = alloc;
#line 440 "../src/Widgets/CropView.vala"
	if (pixbuf_height > _tmp6_.height) {
#line 1423 "CropView.c"
		GtkAllocation _tmp7_;
		GtkAllocation _tmp8_;
#line 441 "../src/Widgets/CropView.vala"
		_tmp7_ = alloc;
#line 441 "../src/Widgets/CropView.vala"
		scale = _tmp7_.height / ((gdouble) pixbuf_height);
#line 442 "../src/Widgets/CropView.vala"
		pixbuf_width = (gint) floor (scale * pixbuf_width);
#line 443 "../src/Widgets/CropView.vala"
		_tmp8_ = alloc;
#line 443 "../src/Widgets/CropView.vala"
		pixbuf_height = _tmp8_.height;
#line 1436 "CropView.c"
	}
#line 446 "../src/Widgets/CropView.vala"
	_tmp9_ = self->priv->_pixbuf;
#line 446 "../src/Widgets/CropView.vala"
	_tmp10_ = gdk_pixbuf_scale_simple (_tmp9_, pixbuf_width, pixbuf_height, GDK_INTERP_BILINEAR);
#line 446 "../src/Widgets/CropView.vala"
	pixbuf = _tmp10_;
#line 448 "../src/Widgets/CropView.vala"
	_tmp11_ = alloc;
#line 448 "../src/Widgets/CropView.vala"
	self->priv->offset_x = (_tmp11_.width / 2) - (pixbuf_width / 2);
#line 449 "../src/Widgets/CropView.vala"
	_tmp12_ = alloc;
#line 449 "../src/Widgets/CropView.vala"
	self->priv->offset_y = (_tmp12_.height / 2) - (pixbuf_height / 2);
#line 451 "../src/Widgets/CropView.vala"
	_tmp13_ = pixbuf;
#line 451 "../src/Widgets/CropView.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp13_, (gdouble) self->priv->offset_x, (gdouble) self->priv->offset_y);
#line 452 "../src/Widgets/CropView.vala"
	cairo_paint (cr);
#line 454 "../src/Widgets/CropView.vala"
	_tmp14_ = self->priv->_pixbuf;
#line 454 "../src/Widgets/CropView.vala"
	scale = pixbuf_width / ((gdouble) gdk_pixbuf_get_width (_tmp14_));
#line 456 "../src/Widgets/CropView.vala"
	_tmp15_ = self->priv->area;
#line 456 "../src/Widgets/CropView.vala"
	x = self->priv->offset_x + ((gint) floor (_tmp15_.x * scale));
#line 457 "../src/Widgets/CropView.vala"
	_tmp16_ = self->priv->area;
#line 457 "../src/Widgets/CropView.vala"
	y = self->priv->offset_y + ((gint) floor (_tmp16_.y * scale));
#line 458 "../src/Widgets/CropView.vala"
	_tmp17_ = self->priv->area;
#line 458 "../src/Widgets/CropView.vala"
	w = (gint) floor (_tmp17_.width * scale);
#line 459 "../src/Widgets/CropView.vala"
	_tmp18_ = self->priv->area;
#line 459 "../src/Widgets/CropView.vala"
	h = (gint) floor (_tmp18_.height * scale);
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_ = g_new0 (gint, 8 * 2);
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[0] = x;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[1] = y;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[2] = x + (w / 2);
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[3] = y;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[4] = x + w;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[5] = y;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[6] = x + w;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[7] = y + (h / 2);
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[8] = x + w;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[9] = y + h;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[10] = x + (w / 2);
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[11] = y + h;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[12] = x;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[13] = y + h;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[14] = x;
#line 461 "../src/Widgets/CropView.vala"
	_tmp19_[15] = y + (h / 2);
#line 461 "../src/Widgets/CropView.vala"
	self->priv->pos = (g_free (self->priv->pos), NULL);
#line 461 "../src/Widgets/CropView.vala"
	self->priv->pos = _tmp19_;
#line 461 "../src/Widgets/CropView.vala"
	self->priv->pos_length1 = 8;
#line 461 "../src/Widgets/CropView.vala"
	self->priv->pos_length2 = 2;
#line 472 "../src/Widgets/CropView.vala"
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) w, (gdouble) h);
#line 473 "../src/Widgets/CropView.vala"
	cairo_set_source_rgba (cr, 0.1, 0.1, 0.1, 0.2);
#line 474 "../src/Widgets/CropView.vala"
	cairo_fill (cr);
#line 476 "../src/Widgets/CropView.vala"
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) w, (gdouble) h);
#line 477 "../src/Widgets/CropView.vala"
	cairo_set_source_rgb (cr, 1.0, 1.0, 1.0);
#line 478 "../src/Widgets/CropView.vala"
	cairo_set_line_width (cr, 1.0);
#line 479 "../src/Widgets/CropView.vala"
	cairo_stroke (cr);
#line 481 "../src/Widgets/CropView.vala"
	if (self->handles_visible) {
#line 1536 "CropView.c"
		{
			gint i = 0;
#line 482 "../src/Widgets/CropView.vala"
			i = 0;
#line 1541 "CropView.c"
			{
				gboolean _tmp20_ = FALSE;
#line 482 "../src/Widgets/CropView.vala"
				_tmp20_ = TRUE;
#line 482 "../src/Widgets/CropView.vala"
				while (TRUE) {
#line 1548 "CropView.c"
					gint* _tmp22_;
					gint _tmp22__length1;
					gint _tmp22__length2;
					gint _tmp23_;
					gint* _tmp24_;
					gint _tmp24__length1;
					gint _tmp24__length2;
					gint _tmp25_;
#line 482 "../src/Widgets/CropView.vala"
					if (!_tmp20_) {
#line 1559 "CropView.c"
						gint _tmp21_;
#line 482 "../src/Widgets/CropView.vala"
						_tmp21_ = i;
#line 482 "../src/Widgets/CropView.vala"
						i = _tmp21_ + 1;
#line 1565 "CropView.c"
					}
#line 482 "../src/Widgets/CropView.vala"
					_tmp20_ = FALSE;
#line 482 "../src/Widgets/CropView.vala"
					if (!(i < 8)) {
#line 482 "../src/Widgets/CropView.vala"
						break;
#line 1573 "CropView.c"
					}
#line 483 "../src/Widgets/CropView.vala"
					_tmp22_ = self->priv->pos;
#line 483 "../src/Widgets/CropView.vala"
					_tmp22__length1 = self->priv->pos_length1;
#line 483 "../src/Widgets/CropView.vala"
					_tmp22__length2 = self->priv->pos_length2;
#line 483 "../src/Widgets/CropView.vala"
					_tmp23_ = _tmp22_[(i * _tmp22__length2) + 0];
#line 483 "../src/Widgets/CropView.vala"
					_tmp24_ = self->priv->pos;
#line 483 "../src/Widgets/CropView.vala"
					_tmp24__length1 = self->priv->pos_length1;
#line 483 "../src/Widgets/CropView.vala"
					_tmp24__length2 = self->priv->pos_length2;
#line 483 "../src/Widgets/CropView.vala"
					_tmp25_ = _tmp24_[(i * _tmp24__length2) + 1];
#line 483 "../src/Widgets/CropView.vala"
					cairo_arc (cr, (gdouble) _tmp23_, (gdouble) _tmp25_, (gdouble) SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_RADIUS, 0.0, 2 * G_PI);
#line 484 "../src/Widgets/CropView.vala"
					cairo_set_source_rgb (cr, 0.7, 0.7, 0.7);
#line 485 "../src/Widgets/CropView.vala"
					cairo_fill (cr);
#line 1597 "CropView.c"
				}
			}
		}
	}
#line 489 "../src/Widgets/CropView.vala"
	self->priv->current_scale = scale;
#line 491 "../src/Widgets/CropView.vala"
	result = TRUE;
#line 491 "../src/Widgets/CropView.vala"
	_g_object_unref0 (pixbuf);
#line 491 "../src/Widgets/CropView.vala"
	return result;
#line 1610 "CropView.c"
}

static gboolean
switchboard_plug_user_accounts_widgets_crop_view_in_quad (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                          gint qx,
                                                          gint qy,
                                                          gint qw,
                                                          gint qh,
                                                          gint x,
                                                          gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 494 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 495 "../src/Widgets/CropView.vala"
	if (x > qx) {
#line 495 "../src/Widgets/CropView.vala"
		_tmp2_ = x < (qx + qw);
#line 1632 "CropView.c"
	} else {
#line 495 "../src/Widgets/CropView.vala"
		_tmp2_ = FALSE;
#line 1636 "CropView.c"
	}
#line 495 "../src/Widgets/CropView.vala"
	if (_tmp2_) {
#line 495 "../src/Widgets/CropView.vala"
		_tmp1_ = y > qy;
#line 1642 "CropView.c"
	} else {
#line 495 "../src/Widgets/CropView.vala"
		_tmp1_ = FALSE;
#line 1646 "CropView.c"
	}
#line 495 "../src/Widgets/CropView.vala"
	if (_tmp1_) {
#line 495 "../src/Widgets/CropView.vala"
		_tmp0_ = y < (qy + qh);
#line 1652 "CropView.c"
	} else {
#line 495 "../src/Widgets/CropView.vala"
		_tmp0_ = FALSE;
#line 1656 "CropView.c"
	}
#line 495 "../src/Widgets/CropView.vala"
	result = _tmp0_;
#line 495 "../src/Widgets/CropView.vala"
	return result;
#line 1662 "CropView.c"
}

static void
switchboard_plug_user_accounts_widgets_crop_view_apply_cursor (SwitchboardPlugUserAccountsWidgetsCropView* self)
{
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkCursor* _tmp3_;
#line 498 "../src/Widgets/CropView.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/Widgets/CropView.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 499 "../src/Widgets/CropView.vala"
	_tmp1_ = gdk_display_get_default ();
#line 499 "../src/Widgets/CropView.vala"
	_tmp2_ = gdk_cursor_new_for_display (_tmp1_, self->priv->current_operation);
#line 499 "../src/Widgets/CropView.vala"
	_tmp3_ = _tmp2_;
#line 499 "../src/Widgets/CropView.vala"
	gdk_window_set_cursor (_tmp0_, _tmp3_);
#line 499 "../src/Widgets/CropView.vala"
	_g_object_unref0 (_tmp3_);
#line 1686 "CropView.c"
}

static gint
switchboard_plug_user_accounts_widgets_crop_view_x_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                              gint ax)
{
	gint result;
#line 502 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 503 "../src/Widgets/CropView.vala"
	if (ax < 0) {
#line 504 "../src/Widgets/CropView.vala"
		result = 1;
#line 504 "../src/Widgets/CropView.vala"
		return result;
#line 1702 "CropView.c"
	} else {
		GdkRectangle _tmp0_;
		GdkPixbuf* _tmp1_;
#line 505 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->area;
#line 505 "../src/Widgets/CropView.vala"
		_tmp1_ = self->priv->_pixbuf;
#line 505 "../src/Widgets/CropView.vala"
		if ((ax + _tmp0_.width) > gdk_pixbuf_get_width (_tmp1_)) {
#line 506 "../src/Widgets/CropView.vala"
			result = 2;
#line 506 "../src/Widgets/CropView.vala"
			return result;
#line 1716 "CropView.c"
		}
	}
#line 507 "../src/Widgets/CropView.vala"
	result = 0;
#line 507 "../src/Widgets/CropView.vala"
	return result;
#line 1723 "CropView.c"
}

static gint
switchboard_plug_user_accounts_widgets_crop_view_y_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                              gint ay)
{
	gint result;
#line 510 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 511 "../src/Widgets/CropView.vala"
	if (ay < 0) {
#line 512 "../src/Widgets/CropView.vala"
		result = 1;
#line 512 "../src/Widgets/CropView.vala"
		return result;
#line 1739 "CropView.c"
	} else {
		GdkRectangle _tmp0_;
		GdkPixbuf* _tmp1_;
#line 513 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->area;
#line 513 "../src/Widgets/CropView.vala"
		_tmp1_ = self->priv->_pixbuf;
#line 513 "../src/Widgets/CropView.vala"
		if ((ay + _tmp0_.height) > gdk_pixbuf_get_height (_tmp1_)) {
#line 514 "../src/Widgets/CropView.vala"
			result = 2;
#line 514 "../src/Widgets/CropView.vala"
			return result;
#line 1753 "CropView.c"
		}
	}
#line 515 "../src/Widgets/CropView.vala"
	result = 0;
#line 515 "../src/Widgets/CropView.vala"
	return result;
#line 1760 "CropView.c"
}

static gint
switchboard_plug_user_accounts_widgets_crop_view_width_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                  gint aw,
                                                                  gint ax)
{
	gint result;
#line 518 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 519 "../src/Widgets/CropView.vala"
	if (aw < 0) {
#line 520 "../src/Widgets/CropView.vala"
		result = 1;
#line 520 "../src/Widgets/CropView.vala"
		return result;
#line 1777 "CropView.c"
	} else {
		GdkPixbuf* _tmp0_;
#line 521 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->_pixbuf;
#line 521 "../src/Widgets/CropView.vala"
		if (aw > (gdk_pixbuf_get_width (_tmp0_) - ax)) {
#line 522 "../src/Widgets/CropView.vala"
			result = 2;
#line 522 "../src/Widgets/CropView.vala"
			return result;
#line 1788 "CropView.c"
		}
	}
#line 523 "../src/Widgets/CropView.vala"
	result = 0;
#line 523 "../src/Widgets/CropView.vala"
	return result;
#line 1795 "CropView.c"
}

static gint
switchboard_plug_user_accounts_widgets_crop_view_height_in_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                                   gint ah,
                                                                   gint ay)
{
	gint result;
#line 526 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 527 "../src/Widgets/CropView.vala"
	if (ah < 0) {
#line 528 "../src/Widgets/CropView.vala"
		result = 1;
#line 528 "../src/Widgets/CropView.vala"
		return result;
#line 1812 "CropView.c"
	} else {
		GdkPixbuf* _tmp0_;
#line 529 "../src/Widgets/CropView.vala"
		_tmp0_ = self->priv->_pixbuf;
#line 529 "../src/Widgets/CropView.vala"
		if (ah > (gdk_pixbuf_get_height (_tmp0_) - ay)) {
#line 530 "../src/Widgets/CropView.vala"
			result = 2;
#line 530 "../src/Widgets/CropView.vala"
			return result;
#line 1823 "CropView.c"
		}
	}
#line 531 "../src/Widgets/CropView.vala"
	result = 0;
#line 531 "../src/Widgets/CropView.vala"
	return result;
#line 1830 "CropView.c"
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_construct (GType object_type)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self = NULL;
#line 24 "../src/Widgets/CropView.vala"
	self = (SwitchboardPlugUserAccountsWidgetsCropView*) g_object_new (object_type, NULL);
#line 24 "../src/Widgets/CropView.vala"
	return self;
#line 1841 "CropView.c"
}

SwitchboardPlugUserAccountsWidgetsCropView*
switchboard_plug_user_accounts_widgets_crop_view_new (void)
{
#line 24 "../src/Widgets/CropView.vala"
	return switchboard_plug_user_accounts_widgets_crop_view_construct (SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW);
#line 1849 "CropView.c"
}

GdkPixbuf*
switchboard_plug_user_accounts_widgets_crop_view_get_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 29 "../src/Widgets/CropView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/CropView.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 30 "../src/Widgets/CropView.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/CropView.vala"
	return result;
#line 1865 "CropView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/Widgets/CropView.vala"
	return self ? g_object_ref (self) : NULL;
#line 1873 "CropView.c"
}

void
switchboard_plug_user_accounts_widgets_crop_view_set_pixbuf (SwitchboardPlugUserAccountsWidgetsCropView* self,
                                                             GdkPixbuf* value)
{
	GdkPixbuf* _tmp0_;
#line 32 "../src/Widgets/CropView.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Widgets/CropView.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/Widgets/CropView.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 33 "../src/Widgets/CropView.vala"
	self->priv->_pixbuf = _tmp0_;
#line 34 "../src/Widgets/CropView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 32 "../src/Widgets/CropView.vala"
	g_object_notify_by_pspec ((GObject *) self, switchboard_plug_user_accounts_widgets_crop_view_properties[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY]);
#line 1893 "CropView.c"
}

static void
switchboard_plug_user_accounts_widgets_crop_view_class_init (SwitchboardPlugUserAccountsWidgetsCropViewClass * klass,
                                                             gpointer klass_data)
{
#line 24 "../src/Widgets/CropView.vala"
	switchboard_plug_user_accounts_widgets_crop_view_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Widgets/CropView.vala"
	g_type_class_adjust_private_offset (klass, &SwitchboardPlugUserAccountsWidgetsCropView_private_offset);
#line 24 "../src/Widgets/CropView.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) switchboard_plug_user_accounts_widgets_crop_view_real_button_press_event;
#line 24 "../src/Widgets/CropView.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) switchboard_plug_user_accounts_widgets_crop_view_real_motion_notify_event;
#line 24 "../src/Widgets/CropView.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) switchboard_plug_user_accounts_widgets_crop_view_real_button_release_event;
#line 24 "../src/Widgets/CropView.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) switchboard_plug_user_accounts_widgets_crop_view_real_draw;
#line 24 "../src/Widgets/CropView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_switchboard_plug_user_accounts_widgets_crop_view_get_property;
#line 24 "../src/Widgets/CropView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_switchboard_plug_user_accounts_widgets_crop_view_set_property;
#line 24 "../src/Widgets/CropView.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_plug_user_accounts_widgets_crop_view_finalize;
#line 1918 "CropView.c"
	/**
	         * The current pixbuf
	         */
#line 24 "../src/Widgets/CropView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY, switchboard_plug_user_accounts_widgets_crop_view_properties[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1924 "CropView.c"
	/**
	         * signal that is emitted when the selection area is changed in any way
	         */
#line 24 "../src/Widgets/CropView.vala"
	switchboard_plug_user_accounts_widgets_crop_view_signals[SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_AREA_CHANGED_SIGNAL] = g_signal_new ("area-changed", SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1930 "CropView.c"
}

static void
switchboard_plug_user_accounts_widgets_crop_view_instance_init (SwitchboardPlugUserAccountsWidgetsCropView * self,
                                                                gpointer klass)
{
	gint* _tmp0_;
#line 24 "../src/Widgets/CropView.vala"
	self->priv = switchboard_plug_user_accounts_widgets_crop_view_get_instance_private (self);
#line 41 "../src/Widgets/CropView.vala"
	self->quadratic_selection = FALSE;
#line 46 "../src/Widgets/CropView.vala"
	self->handles_visible = TRUE;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_ = g_new0 (gint, 8 * 2);
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[0] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[1] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[2] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[3] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[4] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[5] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[6] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[7] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[8] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[9] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[10] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[11] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[12] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[13] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[14] = 0;
#line 66 "../src/Widgets/CropView.vala"
	_tmp0_[15] = 0;
#line 66 "../src/Widgets/CropView.vala"
	self->priv->pos = _tmp0_;
#line 66 "../src/Widgets/CropView.vala"
	self->priv->pos_length1 = 8;
#line 66 "../src/Widgets/CropView.vala"
	self->priv->pos_length2 = 2;
#line 82 "../src/Widgets/CropView.vala"
	self->priv->current_operation = GDK_ARROW;
#line 107 "../src/Widgets/CropView.vala"
	self->priv->mouse_button_down = FALSE;
#line 1988 "CropView.c"
}

static void
switchboard_plug_user_accounts_widgets_crop_view_finalize (GObject * obj)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
#line 24 "../src/Widgets/CropView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, SwitchboardPlugUserAccountsWidgetsCropView);
#line 56 "../src/Widgets/CropView.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 66 "../src/Widgets/CropView.vala"
	self->priv->pos = (g_free (self->priv->pos), NULL);
#line 24 "../src/Widgets/CropView.vala"
	G_OBJECT_CLASS (switchboard_plug_user_accounts_widgets_crop_view_parent_class)->finalize (obj);
#line 2003 "CropView.c"
}

static GType
switchboard_plug_user_accounts_widgets_crop_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SwitchboardPlugUserAccountsWidgetsCropViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_plug_user_accounts_widgets_crop_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardPlugUserAccountsWidgetsCropView), 0, (GInstanceInitFunc) switchboard_plug_user_accounts_widgets_crop_view_instance_init, NULL };
	GType switchboard_plug_user_accounts_widgets_crop_view_type_id;
	switchboard_plug_user_accounts_widgets_crop_view_type_id = g_type_register_static (gtk_event_box_get_type (), "SwitchboardPlugUserAccountsWidgetsCropView", &g_define_type_info, 0);
	SwitchboardPlugUserAccountsWidgetsCropView_private_offset = g_type_add_instance_private (switchboard_plug_user_accounts_widgets_crop_view_type_id, sizeof (SwitchboardPlugUserAccountsWidgetsCropViewPrivate));
	return switchboard_plug_user_accounts_widgets_crop_view_type_id;
}

GType
switchboard_plug_user_accounts_widgets_crop_view_get_type (void)
{
	static volatile gsize switchboard_plug_user_accounts_widgets_crop_view_type_id__once = 0;
	if (g_once_init_enter (&switchboard_plug_user_accounts_widgets_crop_view_type_id__once)) {
		GType switchboard_plug_user_accounts_widgets_crop_view_type_id;
		switchboard_plug_user_accounts_widgets_crop_view_type_id = switchboard_plug_user_accounts_widgets_crop_view_get_type_once ();
		g_once_init_leave (&switchboard_plug_user_accounts_widgets_crop_view_type_id__once, switchboard_plug_user_accounts_widgets_crop_view_type_id);
	}
	return switchboard_plug_user_accounts_widgets_crop_view_type_id__once;
}

static void
_vala_switchboard_plug_user_accounts_widgets_crop_view_get_property (GObject * object,
                                                                     guint property_id,
                                                                     GValue * value,
                                                                     GParamSpec * pspec)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, SwitchboardPlugUserAccountsWidgetsCropView);
#line 24 "../src/Widgets/CropView.vala"
	switch (property_id) {
#line 24 "../src/Widgets/CropView.vala"
		case SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY:
#line 24 "../src/Widgets/CropView.vala"
		g_value_set_object (value, switchboard_plug_user_accounts_widgets_crop_view_get_pixbuf (self));
#line 24 "../src/Widgets/CropView.vala"
		break;
#line 2044 "CropView.c"
		default:
#line 24 "../src/Widgets/CropView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/CropView.vala"
		break;
#line 2050 "CropView.c"
	}
}

static void
_vala_switchboard_plug_user_accounts_widgets_crop_view_set_property (GObject * object,
                                                                     guint property_id,
                                                                     const GValue * value,
                                                                     GParamSpec * pspec)
{
	SwitchboardPlugUserAccountsWidgetsCropView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_TYPE_CROP_VIEW, SwitchboardPlugUserAccountsWidgetsCropView);
#line 24 "../src/Widgets/CropView.vala"
	switch (property_id) {
#line 24 "../src/Widgets/CropView.vala"
		case SWITCHBOARD_PLUG_USER_ACCOUNTS_WIDGETS_CROP_VIEW_PIXBUF_PROPERTY:
#line 24 "../src/Widgets/CropView.vala"
		switchboard_plug_user_accounts_widgets_crop_view_set_pixbuf (self, g_value_get_object (value));
#line 24 "../src/Widgets/CropView.vala"
		break;
#line 2070 "CropView.c"
		default:
#line 24 "../src/Widgets/CropView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/CropView.vala"
		break;
#line 2076 "CropView.c"
	}
}

